package test.entity;

import java.util.ArrayList;

public class WholeIndexOccupy {

    ArrayList<OccupyPerX> occupyPerXArrayList = new ArrayList<>();

    public WholeIndexOccupy(Integer numberOfGaps){

        for (int i = 0;i < numberOfGaps;i++){

            OccupyPerX occupyPerX = new OccupyPerX();
            occupyPerX.setMinYIndex(1000);
            occupyPerX.setMaxYIndex(-1);
            occupyPerXArrayList.add(occupyPerX);

        }

    }


    public void setOccupyPerXArrayList(OccupyPerX occupyPerX,Integer xIndex){

        OccupyPerX occupyPerXOld = occupyPerXArrayList.get(xIndex);

        Integer minYIndexOld = occupyPerXOld.getMinYIndex();
        Integer maxYIndexOld = occupyPerXOld.getMaxYIndex();

        Integer minYIndexForCal = occupyPerX.getMinYIndex();
        Integer maxYIndexForCal = occupyPerX.getMaxYIndex();

        Integer minYIndexTemp;
        Integer maxYIndexTemp;

        if (minYIndexOld < minYIndexForCal){

            minYIndexTemp = minYIndexOld;

        }
        else{

            minYIndexTemp = minYIndexForCal;

        }


        if (maxYIndexOld > maxYIndexForCal){

            maxYIndexTemp = maxYIndexOld;

        }
        else{

            maxYIndexTemp = maxYIndexForCal;

        }

        OccupyPerX occupyPerX1 = new OccupyPerX();
        occupyPerX1.setMinYIndex(minYIndexTemp);
        occupyPerX1.setMaxYIndex(maxYIndexTemp);
        occupyPerXArrayList.set(xIndex,occupyPerX1);

    }

    public ArrayList<OccupyPerX> getOccupyPerXArrayList() {

        return occupyPerXArrayList;

    }

    public void printOccupy(Double minX,Double minY,Double xGap,Double yGap){

        System.out.println("print REAL-----------------------");

        ArrayList<Point> printPointList = new ArrayList<>();

        for (int i = 0 ; i < occupyPerXArrayList.size();i++){

            OccupyPerX occupyPerX = occupyPerXArrayList.get(i);
            Integer minYIndex = occupyPerX.getMinYIndex();
            Integer maxYIndex = occupyPerX.getMaxYIndex();
            if (maxYIndex != -1 && minYIndex !=1000){

                Double xCor = minX + i * xGap + 0.5 * xGap;
                Double yCor = minY + maxYIndex * yGap + 0.5 * yGap;

                Point point = new Point();
                point.setColX(xCor);
                point.setColY(yCor);
                printPointList.add(point);
//                System.out.println(xCor + " " + yCor);


            }

            }

        for (int i = occupyPerXArrayList.size() -1 ; i >=0 ;i--){

            OccupyPerX occupyPerX = occupyPerXArrayList.get(i);
            Integer minYIndex = occupyPerX.getMinYIndex();
            Integer maxYIndex = occupyPerX.getMaxYIndex();
            if (maxYIndex != -1 && minYIndex !=1000){

                Double xCor = minX + i * xGap + 0.5 * xGap;
                Double yCor = minY + minYIndex * yGap + 0.5 * yGap;

                Point point = new Point();
                point.setColX(xCor);
                point.setColY(yCor);
                printPointList.add(point);

//                System.out.println(xCor + " " + yCor);
            }

        }

        printPointList.add(printPointList.get(0));

        for (int i =0;i< printPointList.size();i++){

            Point point = printPointList.get(i);
            System.out.println(point.getColX() + " " + point.getColY());

        }




        System.out.println("print REAL end-----------");


        }

    }

//    public void cleanDirtyData(){
//
//        for (int i = 0; i < occupyPerXArrayList.size();i++){
//
//
//            Integer temp = occupyPerXArrayList.get(i);
//            if ()
//
//        }

//    }


//}
