package test;

import test.entity.OccupyPerX;
import test.entity.Point;
import test.entity.WholeIndexOccupy;

import java.lang.reflect.Array;
import java.sql.SQLException;
import java.util.ArrayList;

public class Cal {

    ArrayList<OccupyPerX> occupyPerXArrayList = new ArrayList<>();//占用情况

    public ArrayList<Point> calShape() throws SQLException {

        GetPoints getPoints = new GetPoints();
        getPoints.getPoints();

        ArrayList<Point> realShapePoints = getPoints.realShapePoints;//实际形状的平面坐标





//        GetPoints getPoints = new GetPoints();//所有待计算点
        ArrayList<Point> allPoints = getPoints.allPoints;//所有待计算点，铲车作业平面坐标
        Split split = new Split();
        split.cal(realShapePoints);

        ArrayList<Double> xIndexCorList = split.xIndexCorList;//格点横坐标List
        ArrayList<Double> yIndexCorList = split.yIndexCorList;//格点纵坐标List
        WholeIndexOccupy wholeIndexOccupy = split.wholeIndexOccupy;//初始垛位的占用情况

//        wholeIndexOccupy.printOccupy();

        Double xGap = split.xGap;//横向上采用的间隔
        Double yGap = split.yGap;//纵向上采用的间隔

        Double minX = xIndexCorList.get(0);
        Double maxX = xIndexCorList.get(xIndexCorList.size() - 1);
        Double minY = yIndexCorList.get(0);
        Double maxY = yIndexCorList.get(yIndexCorList.size() - 1);
        wholeIndexOccupy.printOccupy(minX,minY,xGap,yGap);


        ArrayList<Point> pointAfterExclude = new ArrayList<>();//过滤后的所有点的坐标


        //对待计算点，进行过滤，过滤掉在网格以外的，这部分后面单独写个过滤类
        for(int i = 0 ; i < allPoints.size();i++){

            Point point = allPoints.get(i);
            Double corX = point.getColX();
            Double corY = point.getColY();

            if ( (corX < maxX) && (corX > minX) && (corY < maxY) && (corY > minY)){

                pointAfterExclude.add(point);

            }

        }

        //占用的网格为1，不占用的网格0
        ArrayList<ArrayList<Integer>> occupyList = changeWholeIndexOccupyToList(wholeIndexOccupy);


        System.out.println("print all points---------------" );

        for (int i = 0; i < pointAfterExclude.size();i++){

            Point point = pointAfterExclude.get(i);
            Double x = point.getColX();
            Double y = point.getColY();


            System.out.println( x + " " + y);


            Integer xIndex = split.identifyXIndex(x);
            Integer yIndex = split.identifyYIndex(y);

            if (yIndex < 100 && yIndex >=0){

                ArrayList<Integer> arrayList = occupyList.get(xIndex);
                arrayList.set(yIndex,0);
                occupyList.set(xIndex,arrayList);


            }



        }
        System.out.println("print all points end -----------");






        for (int i = 0 ; i < occupyList.size();i++){

            ArrayList<Integer> arrayList = occupyList.get(i);

            StringBuffer sb = new StringBuffer();
            for (int jj = 0 ; jj < arrayList.size();jj++){


                if (arrayList.get(jj).toString().equals("0")){
                    sb.append(" ");
                }
                else {
                    sb.append(arrayList.get(jj).toString());
                }


            }


            String arrayListString = sb.toString();

            System.out.println("print string----------" + arrayListString);
            String[] arrays = arrayListString.split("\\s+");
//
//            for (int k = 0;k < arrays.length;k++){
//
//                System.out.println(arrays[k]);
//
//            }

            String maxString ="";


            //这里需要再想想
            for (int j = 0 ; j < arrays.length;j++){

                    String temp = arrays[j];
                    if (temp.length() > maxString.length()){

                        maxString = temp;
                    }

            }

            Integer indexBegin = arrayListString.indexOf(maxString) - 1;
            Integer indexEnd = indexBegin + maxString.length();

            OccupyPerX occupyPerX = new OccupyPerX();
            occupyPerX.setMinYIndex(indexBegin);
            occupyPerX.setMaxYIndex(indexEnd);
            occupyPerXArrayList.add(occupyPerX);

        }


        ArrayList<Point> shape = new ArrayList<>();
        for (int i = 0 ; i < occupyPerXArrayList.size();i++){

            OccupyPerX occupyPerX = occupyPerXArrayList.get(i);
            Double xCor = minX + i * xGap + 0.5 * xGap;
            Integer yIndex = occupyPerX.maxYIndex;
            Double yCor = minY + yIndex * yGap + 0.5 * yGap;
            Point point = new Point();
            point.setColX(xCor);
            point.setColY(yCor);

            shape.add(point);
        }

        for (int i = (occupyPerXArrayList.size() -1) ; i >=0;i--){

            OccupyPerX occupyPerX = occupyPerXArrayList.get(i);
            Double xCor = minX + i * xGap + 0.5 * xGap;
            Integer yIndex = occupyPerX.minYIndex;
            Double yCor = minY + yIndex * yGap + 0.5 * yGap;
            Point point = new Point();
            point.setColX(xCor);
            point.setColY(yCor);

            shape.add(point);
        }

        shape.add(shape.get(0));


//        System.out.println(shape.size());
        for (int i = 0 ; i < shape.size() ; i++){

            System.out.println(shape.get(i).getColX() + " " + shape.get(i).getColY() );
//            System.out.println(shape.get(i).getColY());

        }
        return shape;














    }



    public ArrayList<ArrayList<Integer>> changeWholeIndexOccupyToList(WholeIndexOccupy wholeIndexOccupy){

        ArrayList<OccupyPerX> occupyPerXArrayList = wholeIndexOccupy.getOccupyPerXArrayList();

        System.out.println(occupyPerXArrayList);

        Integer numOfGaps = occupyPerXArrayList.size();

        ArrayList<ArrayList<Integer>> occupyList = new ArrayList<>();

        for (int i = 0 ; i < numOfGaps;i++){

            ArrayList<Integer> arrayList = new ArrayList<>();

            for (int j = 0 ; j < numOfGaps ; j++){

                arrayList.add(0);

            }
            occupyList.add(arrayList);
        }

        for (int i = 0 ; i < occupyPerXArrayList.size(); i++){

            OccupyPerX occupyPerX =  occupyPerXArrayList.get(i);

            Integer minYIndex = occupyPerX.getMinYIndex();

            Integer maxYIndex = occupyPerX.getMaxYIndex();

            ArrayList<Integer> arrayList = occupyList.get(i);

//            if ()

            for (int j = minYIndex ; j < (maxYIndex + 1); j++){

                arrayList.set(j,1);

            }

            occupyList.set(i,arrayList);

        }

        return occupyList;

    }

}
